----------------------------------------------------------------------------------
-- Company:  FE, 2014
-- Engineer: A. Trost
-- 
-- Create Date: 09/12/2013 04:06:56 PM
-- Design Name: VGAsinh
-- Module Name: VGAsinh - Behavioral
-- Project Name: lab2, Zynq delavnica 
-- Target Devices: xc7z020clg484-1
-- Tool Versions:  Vivado 2013.3
-- Description: VGA prikaz okna 512x512  
--  clk50 50MHz, VGA 800x600, 72Hz
-- 
-- Revision: 1.2
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity VGAsinh is
	Generic (RGBwin: STD_LOGIC_VECTOR (7 downto 0) := "01001001";
			 RGBbg: STD_LOGIC_VECTOR (7 downto 0) := "10000000");
    Port ( clk50 : in STD_LOGIC;
           hsync : out  STD_LOGIC;
           vsync : out  STD_LOGIC;
           			
		   rgb_o : out  STD_LOGIC_VECTOR (7 downto 0);
		   tx_o, ty_o: out  STD_LOGIC_VECTOR (8 downto 0);
           en_o : out STD_LOGIC);
end VGAsinh;

architecture Behavioral of VGAsinh is
 signal vgaclk: std_logic := '0';
 signal hst: unsigned(10 downto 0):=(others=>'0');
 signal vst: unsigned(9 downto 0):=(others=>'0');
begin

-- VGA timing proces
pVGA: Process(clk50)
begin
 if rising_edge(clk50) then
	if hst < 1040 then 
		hst<=hst+1;
	else
		hst<=(others=>'0');
		if vst < 666 then
			vst<=vst+1;
		else
			vst<=(others=>'0');
		end if;
	end if;	
	
	-- relativni koordinati v oknu
    tx_o <= std_logic_vector(hst(8 downto 0)-144);  
    ty_o <= std_logic_vector(vst(8 downto 0)-44);
			
	en_o <= '0';
	if hst<800 and vst<600 then
		if hst>=144 and hst<656 and vst>=44 and vst<556 then
			rgb_o <= RGBwin; -- siva barva okna
			en_o <= '1';
		else
			rgb_o <= RGBbg; -- modra barva ozadja
		end if;
	else
		rgb_o <= (others=>'0'); -- zatemnitev
	end if;	
 end if;
end process;

hsync <= '1' when hst>=856 and hst<976 else '0'; 
vsync <= '1' when vst>=637 and vst<643 else '0';   

end Behavioral;
